#ifndef RL_DISPLAY_H
#define RL_DISPLAY_H 1

/***************************************************************************/

#define FASTLED_INTERNAL 1 /* silence FastLED output */

#include "main.h"
#include "rl_render.h"

/***************************************************************************/

/* 
** status LED mode defines
**
** a predefined LED can be used to show the device status 
*/

enum {
	DISPLAY_STATUSLEDMODE_OFF             = 0,  /* show no status light */
	DISPLAY_STATUSLEDMODE_WIFI,                 /* show wifi status */
};

/***************************************************************************/

/*
** status LED colors
*/

#define  DISPLAY_STATUSLED_DISCONNECTED      CRGB::Red
#define  DISPLAY_STATUSLED_CONNECTED         CRGB::Green
#define  DISPLAY_STATUSLED_APMODE            CRGB::Purple
#define  DISPLAY_STATUSLED_CONNECTING        CRGB::Yellow

/***************************************************************************/

/* now the display related storage */

#define DISPLAY_TOTAL_LEDS ( HARDWARE_SEGMENT_1_LEDS + HARDWARE_SEGMENT_2_LEDS )

extern CRGB     ledfield[ DISPLAY_TOTAL_LEDS ];

/*
** prototypes
*/

void Display_UpdateSettings( void );
void Display_Startup( void );
void Display_Handle( void );
void Display_Update( void );
void Display_Clear( void );
void Display_SetStatusLED( uint32_t mode, CRGB color );

/***************************************************************************/

#endif /* RL_DISPLAY_H */