#ifndef RL_SOUND_H
#define RL_SOUND_H 1

/***************************************************************************/

#include "main.h"

/***************************************************************************/

/*
** DFPlayer configuration
*/

#define SOUND_SERIALSPEED             9600
#define SOUND_SERIALFLAGS       SERIAL_8N1
#define SOUND_INITDELAY                500
#define SOUND_RX_PIN                    18  /* the DFPlayer mp3 sound module requires a serial port. The matching */
#define SOUND_TX_PIN                    19  /* pins get defined here */

/***************************************************************************/

#define SOUNDID_OFF        0
#define SOUNDID_ALARM_1    1
#define SOUNDID_ALARM_2    2
#define SOUNDID_ALARM_3    3
#define SOUNDID_ALARM_4    4
#define SOUNDID_ALARM_5    5
#define SOUNDID_ALARM_6    6
#define SOUNDID_ALARM_7    7
#define SOUNDID_ALARM_8    8
#define SOUNDID_ALARM_9    9
#define SOUNDID_ALARM_10  10 
#define SOUNDID_ALARM_11  11
#define SOUNDID_Alert_1   12
#define SOUNDID_BELL_1    13
#define SOUNDID_BELL_2    14
#define SOUNDID_BELL_4    15
#define SOUNDID_BLANK     16
#define SOUNDID_DOOR_1    17
#define SOUNDID_DOOR_2    18
#define SOUNDID_DOOR_3    19
#define SOUNDID_DOOR_4    20
#define SOUNDID_DOOR_5    21
#define SOUNDID_NOTIFY_1  22
#define SOUNDID_NOTIFY_2  23
#define SOUNDID_NOTIFY_3  24
#define SOUNDID_NOTIFY_4  25 
#define SOUNDID_NOTIFY_5  26  
#define SOUNDID_NOTIFY_6  27
#define SOUNDID_PHONE_1   28
#define SOUNDID_STARTUP_2 29
#define SOUNDID_TEST_1    30
#define SOUNDID_TEST_2    31

/***************************************************************************/

#define SOUNDDEVICE_VOLUME_MIN    0
#define SOUNDDEVICE_VOLUME_MAX   30

/***************************************************************************/

/*
** prototypes
*/


void     Sound_Setup( void );
void     Sound_Play( uint32_t sampleid, bool force );
void     Sound_SetVolume( uint32_t volume );

/***************************************************************************/

#endif /* RL_SOUND_H */

