/*
**   rl_testmode.cpp
**
**   Copyright 2021 Guido Mersmann <geit@geit.de>
**   All rights reserved.
**
**
**   This file is crap :D
**
**   It is used to test effects and support the building of the device.
**   The TRAIN mode for example is used to check if the orientation of the
**   LED strip and the wiring is OK.
**
**   I also used the code in here to work on stuff without interfering with
**   the normal operation and more important without causing a boot loop.
**
**   The code in was just needed to do effective quick tests, not to
**   be optimized in any way.
**
**   Do not take this file into account, when it comes to coding skills. :D
**
**   IMPORTANT:
**
**   To activate this code ENABLE_TESTMODE must be enabled in "main.h"
**   Global mode must be set to "test mode" in web interface and finally you
**   can select the type of test in the misc section.
**   
**   For safety reasons global mode, test mode settings to not survive a
**   reboot and cannot be saved.
*/

/***************************************************************************/

#include "rl_testmode.h"
#include "rl_render.h"

/***************************************************************************/

#if ENABLE_TESTMODE

/***************************************************************************/

uint32_t testmode_mode;
uint32_t testmode_automode;
uint32_t testmode_autospeed;


#define RLRD_TESTMODE_LOOPS DISPLAY_TOTAL_LEDS

/* /// TestMode_Setup() 
**
*/

/***************************************************************************/

void TestMode_Setup( void )
{
	testmode_mode  = RLRD_TESTMODE_OFF;
	testmode_autospeed = 0;
	testmode_automode  = 0;
}
/* \\\ */

/* /// TestMode_Handle() 
**
*/

/***************************************************************************/

void TestMode_Handle( void )
{
uint32_t i, i2;
CRGB color, color2;
#if 0
	static int light;

	light = analogRead( 34 );
	delay( 1000 );
	debug(( "plah: %d\n", light ));
#endif

	if ( !testmode_automode ) {
		if( rlrd.rlrd_TestMode != testmode_mode ) {
			if( rlrd.rlrd_TestMode != RLRD_TESTMODE_AUTO ) {
				testmode_mode = rlrd.rlrd_TestMode;
			} else {
				testmode_automode = 1;
				testmode_autospeed = 0;
				testmode_mode = RLRD_TESTMODE_AUTOFIRST;
				debug(( "auto enabled}n" ));
			}
		}
	}
	if( testmode_automode ) {
		if( rlrd.rlrd_TestMode != RLRD_TESTMODE_AUTO ) {
				testmode_automode = 0;
				debug(( "auto diabled\n" ));
		} else {
			testmode_autospeed++;
			if( testmode_autospeed >= RLRD_TESTMODE_LOOPS ) {
				testmode_autospeed = 0;
				testmode_mode++;
				debug(( "auto mode change\n" ));
				if( testmode_mode == RLRD_TESTMODE_AUTOLAST ) {
					testmode_mode = RLRD_TESTMODE_AUTOFIRST;
				}
			}
		}
	}

	switch( testmode_mode ) {
		case RLRD_TESTMODE_OFF:
			break;
		case RLRD_TESTMODE_TRAIN:
			{
				CRGB buf = ledfield[ 0 ];
				uint32_t count = 0;
					for( i = 0 ; i < ( DISPLAY_TOTAL_LEDS - 1 ) ; i++ ) {
						ledfield[ i ] = ledfield[ i + 1 ];
						if( ledfield[i] ) { /* lame trick to avoid init code. If more than 3 leds are enabled, there is no train */
							count++;
						}
					}
					ledfield[ i ] = buf;
					if( count >= 4 ) { /* this is a tricky cheat to avoid some init */
						fill_solid( ledfield, DISPLAY_TOTAL_LEDS, CRGB::Black);
						fill_solid( ledfield, 3, CRGB::Blue);
					}
			}
			break;
		case RLRD_TESTMODE_AUTO:
			break;
		case RLRD_TESTMODE_RED:
			color     = CRGB::Red;
			color2    = color; 
			goto FillBufferUnique;
		case RLRD_TESTMODE_GREEN:
			color     = CRGB::Green;
			color2    = color; 
			goto FillBufferUnique;
		case RLRD_TESTMODE_BLUE:
			color     = CRGB::Blue;
			color2    = color; 
			goto FillBufferUnique;
		case RLRD_TESTMODE_WHITE:
			color     = CRGB::White;
			color2    = color; 
			goto FillBufferUnique;
		case RLRD_TESTMODE_STRIPLENGTH:
			color     = CRGB::Green;
			color2    = CRGB::White;
			goto FillBuffer;
		case RLRD_TESTMODE_STRIPLENGTHM1:
			color     = CRGB::White;
			color2    = CRGB::Green;
			goto FillBuffer;
FillBufferUnique:
			color2 = color; 
FillBuffer:
			Display_Clear(); /* just make sure we clear previous content, so we are able to detect a wrong configured LED strip */
			i2 = HARDWARE_SEGMENT_1_LEDS;
			if( testmode_mode == RLRD_TESTMODE_STRIPLENGTHM1 ) { i2--; }   /* we reduce the amount of LEDs */
			for( i = 0 ; i < i2 ; i++ ) {
				ledfield[ i ] = color;
			}
#if HARDWARE_SEGMENT_2_LEDS != 0          /* do we have a secondary LED Strip? */
			i2 = HARDWARE_SEGMENT_2_LEDS;
			if( testmode_mode == RLRD_TESTMODE_STRIPLENGTHM1 ) { i2--; }   /* we reduce the amount of LEDs */
			for( i = 0 ; i < i2 ; i++ ) {
				ledfield[ HARDWARE_SEGMENT_1_LEDS + i ] = color2;
			}
#endif
			break;
	}
//	debug(( "power is %dmW\n", calculate_unscaled_power_mW( ledfield, NUMBEROF_LEDS ) ));
}
/* \\\ */

/***************************************************************************/

#endif