#ifndef RL_WEBSERVER_H
#define RL_WEBSERVER_H 1

/***************************************************************************/

#include <WebServer.h>

#include "main.h"

/***************************************************************************/

#if ENABLE_FAUXMO
  #define WEBSERVER_PORT     81   /* fauxmo is blocking port 80, so use port 81 */
#else 
  #define WEBSERVER_PORT     80   /* port used for accessing the webserver */
#endif

/***************************************************************************/

/*
** externals 
*/

extern uint32_t webserver_action;
extern String htmlpage;
extern WebServer server;

/***************************************************************************/

/*
** prototypes
*/

void WebServer_AppendWiFiSignal( void );
void WebServer_AppendHeader( bool refreshMode, uint32_t active ) ;
void WebServer_AppendFooter( void );

void WebServer_Setup( void );
void WebServer_HandleWebPage( uint32_t pageid );
void WebServer_CreateStatus( void );
void WebServer_HandleAction( void );
bool WebServer_IsAuthentified();
void WebServer_HandleLogin();
void WebServer_HandleRoot();
void WebServer_HandleNotFound();

/***************************************************************************/

#endif /* RL_WEBSERVER_H */
