#ifndef RL_WIFI_H
#define RL_WIFI_H 1

/***************************************************************************/

#include <WiFi.h>
#include <WiFiUdp.h>

#include "main.h"

/***************************************************************************/

/*
** wifi related defines 
*/

#define WIFI_ACCESSPOINT_NAME "ESP32_" APPLICATIONNAME_NSUC

/***************************************************************************/

/*
** the wifi mode state engine defines
*/
enum{
	WIFIMODE_STATE_CONNECTING = 0,
	WIFIMODE_STATE_CONNECTED,
	WIFIMODE_STATE_APMODE,
};

extern uint32_t wifi_mode;
extern char     wifi_hostname[];

/***************************************************************************/

/*
** prototypes
*/

void Wifi_SetupStationMode( void );
void Wifi_SetupAccessPointMode( void );
void Wifi_Handle( void );
void Wifi_SwapNetwork( void );

/***************************************************************************/

#endif /* RL_WIFI_H */
